#include <math.h>
#include "dll.h"

/*
  The RANDU random number generator. Do not use this function
  for generating random numbers!! Already in three dimensions,
  points obtained from this generator are located on hyperplanes.

  double *x    : vector, contains random numbers after execution
  double *n    : scalar, length of x
  double *seed : scalar, seed of generator
*/

EXTERN int EXPORT randu (double *x, double *n, double *seed)
{
  long i, nn= (long) *n;
  double a = 65539.0, m = 2147483648.0;/* 2^31 */
  printf("Calling randu ...\n");/* This output goes to the shell! */

  *x = *seed;
  for (i=1; i<nn; i++)
   *(x+i)  = fmod(a * *(x+i-1),m);
  *seed=fmod (a * *(x+nn-1),m);
  for (i=0; i<nn; i++)
   *(x+i)  = *(x+i)/m;

  return (0);
}
